////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    ICMP-Popup.js (Javascript file for ICMP-POPUP.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

// Dialog/Message box defines
var MB_OK =                     0x00000000;
var MB_OKCANCEL =               0x00000001;
var MB_ABORTRETRYIGNORE =       0x00000002;
var MB_YESNOCANCEL =            0x00000003;
var MB_YESNO =                  0x00000004;
var MB_RETRYCANCEL =            0x00000005;

var MB_ICONHAND =               0x00000010;
var MB_ICONQUESTION =           0x00000020;
var MB_ICONEXCLAMATION =        0x00000030;
var MB_ICONASTERISK  =          0x00000040;

var MB_USERICON =               0x00000080;
var MB_ICONWARNING =            MB_ICONEXCLAMATION;
var MB_ICONERROR =              MB_ICONHAND;

var MB_ICONINFORMATION =        MB_ICONASTERISK;
var MB_ICONSTOP =               MB_ICONHAND;

var IDOK =              1;
var IDCANCEL =          2;
var IDABORT =           3;
var IDRETRY =           4;
var IDIGNORE =          5;
var IDYES =             6;
var IDNO =              7;

var g_LocalPorts = null;
var g_RemotePorts = null;
var g_OldLocalPorts = null;
var g_OldRemotePorts = null;

function Page_OnLoad()
{
	var args = window.dialogArguments;

	UserManager.WatchForFREIntegStart();

	if(args[0] == "local") {
		RLocal.checked = true;
		RRemote.checked = false;
	}
	else
	{
		RLocal.checked = false;
		RRemote.checked = true;
	}

	g_LocalPorts = new ActiveXObject("ccFWSettg.PortList");
	g_RemotePorts = new ActiveXObject("ccFWSettg.PortList");
	
	g_OldLocalPorts = args[1];
	g_OldRemotePorts = args[2];
	
	OKB.focus();
}

function UserManager_OnFREIntegratorStart()
{
	window.navigate('res://closeme.xyz');
}

function getICMPInfo(row, item)
{
    var nCol = 0;
    switch (item.toLowerCase())
    {
        case "checked":
            nCol = 0;
            break;
        case "value":
            nCol = 1;
            break;
        case "name":
            nCol = 2;
            break;
    }
    return ICMPList.MsgTypes.rows[row].cells[nCol];
}

function SelIndividual_OnClick()
{
	Range.style.display = "none";
	List.style.display = "none";
	Individual.style.display = "";
    RPortRange.checked = false;
	RPortList.checked = false;
	RSinglePort.checked = true;
}

function SelList_OnClick()
{
	Individual.style.display = "none";
	Range.style.display = "none";
	List.style.display = "";
    RPortRange.checked = false;
	RSinglePort.checked = false;
	RPortList.checked = true;
}

function SelRange_OnClick()
{
	Individual.style.display = "none";
	List.style.display = "none";
	Range.style.display = "";
	RSinglePort.checked = false;
	RPortList.checked = false;
    RPortRange.checked = true;
}

function OKB_OnClick()
{
    //
    // Prepare some variables to simplify access to objects.
    //
    var Error = false;
    var xmlOut = new ActiveXObject("Microsoft.XMLDOM");
    xmlOut.loadXML(RLocal.checked?"<LocalPorts/>":"<RemotePorts/>");
    var oMsgTypes = ICMPList.MsgTypes.rows;
    var nNumRecs = oMsgTypes.length;

    //
    // Is this the specified ports list?
    //
    if (PortType[0].checked)
    {
        //
        // Iterate over each service listed in our dialog.
        //
        for(var nElem = 0; 
            nElem < nNumRecs;
            nElem++)
        {
            //
            // If the user checked this service (via the nested child INPUT tag), add it to our list.
            //
            if (getICMPInfo(nElem, "checked").children[0].checked)
            {
                if (IsValidPort(getICMPInfo(nElem, "value").innerText))
				{
					var cPort = new ActiveXObject("ccFWSettg.Port");

					cPort.PortNum = getICMPInfo(nElem, "value").innerText;
					cPort.Type = 0;

					if(!AddPortToList(Locality[0].checked, cPort))
					{
						Error = true;
						break;
					}	
				}
                else
                {
					webWind.MsgBox(StrID("InvalidCommand"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
                    Error = true;
                    break;
                }
            }
        }
    }
    //
    // Is this individually specified ports?
    //
    else if (PortType[1].checked)
    {
        var aPort = EnterPorts.value.split(" ");

        // 
        // Cycle through space delimited list and add each port.
        //
        for(var nElem = 0; nElem < aPort.length; nElem++)
        {
            //
            // Valid port?
            //
            if (IsValidPort(aPort[nElem]))
            {
				var cPort = new ActiveXObject("ccFWSettg.Port");

				cPort.PortNum = aPort[nElem];
				cPort.Type = 0;

				if(!AddPortToList(Locality[0].checked, cPort))
				{
					Error = true;
					break;
				}
            }
            else
            {
                webWind.MsgBox(StrID("InvalidCommand"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
                Error = true;
                break;
            }
        
        }
    }
    //
    // Is this a port range?
    //
    else if (PortType[2].checked)
    {
        if (IsValidPort(EnterStartPort.value) && IsValidPort(EnterEndPort.value))
		{
			var nStart = parseInt(EnterStartPort.value);
			var nEnd = parseInt(EnterEndPort.value);

			if(nStart <= nEnd)
			{
				var cPort = new ActiveXObject("ccFWSettg.Port");

				cPort.RangeStart = nStart;
				cPort.RangeEnd = nEnd;
				cPort.Type = 1;

				Error = !AddPortToList(Locality[0].checked, cPort);
			}
			else
			{
				webWind.MsgBox(StrID("PortRangeError"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
				Error = true;
			}
		}
        else
        {
            webWind.MsgBox(StrID("InvalidCommand"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
            Error = true;
        }
    }

	if (!Error)
    {
		var retVals = new Array;
	
		retVals[0] = g_LocalPorts;
		retVals[1] = g_RemotePorts;

	    window.returnValue = retVals;
	    window.navigate("res://closeme.xyz");
    }
}

function CancelB_OnClickOrReset()
{
	var retVals = new Array;
	
	retVals[0] = null;
	retVals[1] = null;

	returnValue = retVals;
	window.navigate("res://closeme.xyz");
}

function AddPortToList(localPort, portItem)
{
	var Success = true;

	if(localPort)
	{
		if(null == g_OldLocalPorts.IsPortInList(portItem))
		{
			g_LocalPorts.LastError = 0;
			g_LocalPorts.AppendItem(portItem);
			if(HandleListError(g_LocalPorts.LastError, 1008, 104))
				Success = false;
		}
		else
		{
			webWind.MsgBox(StrID("PortDupeEntry"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
			Success = false;
		}

	}
	else
	{
		if(null == g_OldRemotePorts.IsPortInList(portItem))
		{
			g_RemotePorts.LastError = 0;
			g_RemotePorts.AppendItem(portItem);				
			if(HandleListError(g_RemotePorts.LastError, 1008, 105))
				Success = false;
		}
		else
		{
			webWind.MsgBox(StrID("PortDupeEntry"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
			Success = false;
		}
	}

	return Success;
}