////////////////////////////////////////////////////////////////////////////////////////////
//
// PRODUCT: Norton Internet Security/Symantec Desktop Firewall
//
// NAME:    Ports-Popup.js (Javascript file for Ports-Popup.HTM)
//
// Copyright (c) 2001 by Symantec Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////////////

var g_LocalPorts = null;
var g_RemotePorts = null;
var g_OldLocalPorts = null;
var g_OldRemotePorts = null;

function Page_OnLoad()
{
	var args = window.dialogArguments;

	UserManager.WatchForFREIntegStart();

	if(args[0] == "local") {
		RLocal.checked = true;
		RRemote.checked = false;
	}
	else
	{
		RLocal.checked = false;
		RRemote.checked = true;
	}

	g_LocalPorts = new ActiveXObject("ccFWSettg.PortList");
	g_RemotePorts = new ActiveXObject("ccFWSettg.PortList");

	g_OldLocalPorts = args[1];
	g_OldRemotePorts = args[2];
	
	OKB.focus();
}

function UserManager_OnFREIntegratorStart()
{
 	window.navigate('res://closeme.xyz');
}

function SelIndividual_OnClick()
{
	Range.style.display = "none";
	List.style.display = "none";
	Individual.style.display = "";
    RPortRange.checked = false;
	RPortList.checked = false;
	RSinglePort.checked = true;
}

function SelList_OnClick()
{
	Individual.style.display = "none";
	Range.style.display = "none";
	List.style.display = "";
    RPortRange.checked = false;
	RSinglePort.checked = false;
	RPortList.checked = true;
}

function SelRange_OnClick()
{
	Individual.style.display = "none";
	List.style.display = "none";
	Range.style.display = "";
	RSinglePort.checked = false;
	RPortList.checked = false;
    RPortRange.checked = true;
}

function OKB_OnClick()
{
    //
    // Prepare some variables to simplify access to objects.
    //
    var Error = false;
    var oKnownPortsList = KnownPorts.KnownPortsList;

	var	nList_CheckboxOffset = 0;
	var nList_PortOffset = 1;

    //
    // Is this the specified ports list?
    //
    if (PortType[0].checked)
    {
        //
        // Iterate over each service listed in our dialog.
        //
		for(var i=0; i < oKnownPortsList.rows.length;i++)
		{
			if(oKnownPortsList.rows[i].cells[nList_CheckboxOffset].children[0].checked)
			{
				if(IsValidPort(oKnownPortsList.rows[i].cells[nList_PortOffset].innerText))
				{
					var cPort = new ActiveXObject("ccFWSettg.Port");

					cPort.PortNum = oKnownPortsList.rows[i].cells[nList_PortOffset].innerText;
					cPort.Type = 0;

					if(!AddPortToList(Locality[0].checked, cPort))
					{
						Error = true;
						break;
					}
				}
				else
				{
					webWind.MsgBox(StrID("InvalidPort"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
					Error = true;
					break;
				}
			}
		}
	}
    //
    // Is this individually specified ports?
    //
    else if (PortType[1].checked)
    {
        var aPort = EnterPorts.value.split(" ");

        // 
        // Cycle through space delimited list and add each port.
        //
        for(var nElem = 0; nElem < aPort.length; nElem++)
        {
            //
            // Valid port?
            //
            if (IsValidPort(aPort[nElem]))
            {
                var cPort = new ActiveXObject("ccFWSettg.Port");

				cPort.PortNum = aPort[nElem];
				cPort.Type = 0;

				if(!AddPortToList(Locality[0].checked, cPort))
				{
					Error = true;
					break;
				}
            }
            else
            {
		webWind.MsgBox(StrID("InvalidPort"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);                
                Error = true;
                break;
            }
        
        }
    }
    //
    // Is this a port range?
    //
    else if (PortType[2].checked)
    {
        if (IsValidPort(EnterStartPort.value) && IsValidPort(EnterEndPort.value))
		{				
			var nStart = parseInt(EnterStartPort.value);
			var nEnd = parseInt(EnterEndPort.value);

			if(nStart < nEnd)
			{
				var cPort = new ActiveXObject("ccFWSettg.Port");

				cPort.RangeStart = nStart;
				cPort.RangeEnd = nEnd;
				cPort.Type = 1;

				Error = !AddPortToList(Locality[0].checked, cPort);
			}
			else
			{
				webWind.MsgBox(StrID("PortRangeError"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
				Error = true;
			}
		}
        else
        {
            webWind.MsgBox(StrID("InvalidPort"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
            Error = true;
        }
    }

    if (!Error)
    {
		var retVals = new Array;
	
		retVals[0] = g_LocalPorts;
		retVals[1] = g_RemotePorts;

	    window.returnValue = retVals;
	    window.navigate("res://closeme.xyz");
    }
}

function CancelB_OnClickOrReset()
{
	var retVals = new Array;
	
	retVals[0] = null;
	retVals[1] = null;

	returnValue = retVals;
	window.navigate("res://closeme.xyz");
}

function AddPortToList(localPort, portItem)
{
	var Success = true;

	if(localPort)
	{
		if(null == g_OldLocalPorts.IsPortInList(portItem))
		{
			g_LocalPorts.LastError = 0;
			g_LocalPorts.AppendItem(portItem);
			if(HandleListError(g_LocalPorts.LastError, 1008, 110))
				Success = false;
		}
		else
		{
			webWind.MsgBox(StrID("PortDupeEntry"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
			Success = false;
		}

	}
	else
	{
		if(null == g_OldRemotePorts.IsPortInList(portItem))
		{
			g_RemotePorts.LastError = 0;
			g_RemotePorts.AppendItem(portItem);				
			if(HandleListError(g_RemotePorts.LastError, 1008, 111))
				Success = false;
		}
		else
		{
			webWind.MsgBox(StrID("PortDupeEntry"), UserManager.AppTitle, MB_OK | MB_ICONEXCLAMATION);
			Success = false;
		}
	}

	return Success;
}